{% extends 'base.html.twig' %}

{% block body %}
<div class="mb-4">
    {% if saved %}
        <div class="alert alert-success" role="alert">
            Configurazione salvata.
        </div>
    {% endif %}

    <ul id="mainMenu" class="nav nav-pills" role="tablist">
        <li class="nav-item" role="presentation">
            <button class="nav-link active" id="generale-pill" data-bs-toggle="pill"
                    data-bs-target="#generale" type="button"
                    role="tab" aria-controls="generale" aria-selected="true">Generale
            </button>
        </li>
        <li id="showAdLi" style="display:none" class="nav-item" role="presentation">
            <button class="nav-link " id="ad-pill" data-bs-toggle="pill" data-bs-target="#ad" type="button"
                    role="tab" aria-controls="ad" aria-selected="true">Active directory
            </button>
        </li>
        <li id="showProviderLi" style="display:none" class="nav-item" role="presentation">
            <button class="nav-link " id="provider-pill" data-bs-toggle="pill" data-bs-target="#provider"
                    type="button"
                    role="tab" aria-controls="provider" aria-selected="true">Provider
            </button>
        </li>
        <li class="nav-item" role="presentation">
            <button class="nav-link " id="wireless-pill" data-bs-toggle="pill" data-bs-target="#wireless"
                    type="button"
                    role="tab" aria-controls="provider" aria-selected="true">Wireless
            </button>
        </li>
        <li class="nav-item" role="presentation">
            <button class="nav-link " id="radius-pill" data-bs-toggle="pill" data-bs-target="#radius"
                    type="button"
                    role="tab" aria-controls="provider" aria-selected="true">RADIUS
            </button>
        </li>
        <li class="nav-item" role="presentation">
            <button class="nav-link " id="appleSchool-pill" data-bs-toggle="pill"
                    data-bs-target="#appleSchool" type="button"
                    role="tab" aria-controls="provider" aria-selected="true">AppleSchool
            </button>
        </li>
        <li class="nav-item" role="presentation">
            <button class="nav-link " id="mdmServer-pill" data-bs-toggle="pill"
                    data-bs-target="#mdmServer" type="button"
                    role="tab" aria-controls="provider" aria-selected="true">Server Mdm
            </button>
        </li>
    </ul>
    {{ form_start(form) }}
    {# <form action="{{ url('config_update') }}" method="post" autocomplete="off"> #}
    <input id="fakeUser" type="text" autocomplete="off" style="display: none;"/><input id="fakePw"
                                                                                       type="password"
                                                                                       autocomplete="off"
                                                                                       style="display: none;"/>

    <div id="pillContent" class="tab-content m-3">
        <div class="tab-pane fade show active" id="generale" role="tabpanel"
             aria-labelledby="generale-pill">
            <div class="mb-1">
                {{ form_widget(form.onlyReception, {'attr': {'class' : 'form-check-input'}}) }}
                {{ form_label(form.onlyReception) }}
            </div>
            <div class="mb-1">
                {{ form_widget(form.disableGuest, {'attr': {'class' : 'form-check-input'}}) }}
                {{ form_label(form.disableGuest) }}
            </div>
            <div class="mb-1">
                {{ form_widget(form.disableMikrotik, {'attr': {'class' : 'form-check-input'}}) }}
                {{ form_label(form.disableMikrotik) }}
            </div>
            <div id="mikrotikDiv">
                <div class="mb-1">
                    {{ form_widget(form.disableMikrotikIPs, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.disableMikrotikIPs) }}
                </div>
                <div class="mb-1">
                    {{ form_widget(form.disableMikrotikBypass, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.disableMikrotikBypass) }}
                </div>
            </div>
            <div class="mb-1">
                {{ form_widget(form.guestCanRegisterViaSms, {'attr': {'class' : 'form-check-input'}}) }}
                {{ form_label(form.guestCanRegisterViaSms) }}
            </div>
            <div id="showSkebbyDiv" style="display:none;" class="bgc-grey-25 ms-5 mb-3">
                {{ form_row(form.skebbyUsername) }}
                {{ form_row(form.skebbyPassword) }}
                <p>
                    Ricordarsi di mettere in bypass del hotspot i seguenti URL e di indicare nella scherma
                    di login del hotspot il link per la registrazione:
                </p>
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">URL registrazione via SMS: <a
                                href="{{ absolute_url(path('guest_register_via_sms')) }}">{{ absolute_url(path('guest_register_via_sms')) }}</a>
                    </li>
                    <li class="list-group-item">URL password dimenticata via SMS: <a
                                href="{{ absolute_url(path('guest_password_recover_via_sms')) }}">{{ absolute_url(path('guest_password_recover_via_sms')) }}</a>
                    </li>
                </ul>
            </div>

            <div id="showAdDiv" style="display:none" class="mx-0">
                <div class="mb-1">
                    {{ form_widget(form.userCanChangeOwnPassword, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.userCanChangeOwnPassword) }}
                </div>
                <div class="mb-1">
                    {{ form_widget(form.showBadge, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.showBadge) }}
                </div>
                <div class="mb-1">
                    {{ form_widget(form.teacherCanResetPassword, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.teacherCanResetPassword) }}
                </div>
                <div class="mb-1">
                    {{ form_widget(form.teacherCanSeeList, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.teacherCanSeeList) }}
                </div>
                <div class="mb-1">
                    {{ form_widget(form.teacherCanEnablePersonalDevice, {'attr': {'class' : 'form-check-input'}}) }}
                    {{ form_label(form.teacherCanEnablePersonalDevice) }}
                </div>
            </div>


            <div class="mt-3 d-flex justify-content-center">
                <input type="submit" value="Salva" class="btn btn-primary"/>
            </div>
        </div>
        <div class="tab-pane" id="ad" role="tabpanel" aria-labelledby="ad-pill">
            <h3 class="mt-4">Parametri di connessione con il server active directory</h3>
            {{ form_row(form.active_directory_account_suffix) }}
            {{ form_row(form.active_directory_base_dn) }}
            {{ form_row(form.active_directory_domain_controller) }}
            {{ form_row(form.active_directory_admin_username) }}
            {{ form_row(form.active_directory_admin_password) }}
            {{ form_row(form.active_directory_use_ssl) }}
            {{ form_row(form.active_directory_sync_suffix) }}

            <h3 class="mt-4">Parametri di comportamento di igroove verso active directory</h3>
            {{ form_row(form.active_directory_generated_group_prefix) }}
            {{ form_row(form.active_directory_generated_teacher_group_prefix) }}
            {{ form_row(form.active_directory_generated_provider_group_with_users) }}
            {{ form_row(form.active_directory_generated_teacher_provider_group_with_users) }}
            {{ form_row(form.active_directory_home_folder) }}
            {{ form_row(form.active_directory_home_drive) }}
            {{ form_row(form.active_directory_email_for_error) }}

            <h3 class="mt-4">Criteri per le password</h3>
            {{ form_row(form.active_directory_password_min_char) }}
            {{ form_row(form.active_directory_password_complexity) }}
            {{ form_row(form.active_directory_password_use_dictionary) }}
            {{ form_row(form.active_directory_password_prefix) }}
            {{ form_row(form.active_directory_username_style) }}
            {{ form_row(form.email_length_limit) }}


            <div class="mt-3 d-flex justify-content-center">
                <input type="submit" value="Salva" class="btn btn-primary"/>
            </div>
        </div>

        <div class="tab-pane" id="provider" role="tabpanel" aria-labelledby="provider-pill">
            {% if providers %}
                <ul class="list-group">
                    {% for provider in providers %}
                        <li class="list-group-item d-flex align-items-center">
                            <i class="fa-solid {{ provider.active  ? 'c-teal-500 fa-check' : 'c-deep-orange-500 fa-xmark' }} me-2"></i>

                            <a href="{{ path('config_provider_edit', { 'id': provider.id }) }}">{{ provider.name }}</a>
                            <div class="ms-auto">
                                <a href="{{ path('config_provider_edit', { 'id': provider.id }) }}" class="btn btn-primary btn-sm">Modifica</a>
{#                                <a href="{{ path('app_provider_showmanualsync', {id: provider.id}) }}" class="btn btn-secondary btn-sm">Sync Manuale</a>#}
                            </div>
                        </li>

                    {% endfor %}
                </ul>
            {% endif %}
            <div class="mt-3 d-flex justify-content-center">
                <a class="btn btn-success" href="{{ path('config_provider_new') }}">
                    Aggiungi
                </a>
            </div>
        </div>


        <div class="tab-pane" id="wireless" role="tabpanel" aria-labelledby="wireless-pill">
            {{ form_row(form.wireless_ssid) }}
            {{ form_row(form.wireless_guest_network_type) }}
            {{ form_row(form.wireless_guest_network_rules) }}

            {{ form_row(form.wireless_guest_html_badge) }}
            {{ form_row(form.wireless_guest_html_instructions) }}

            <div class="mt-3 d-flex justify-content-center">
                <input type="submit" value="Salva" class="btn btn-primary"/>
            </div>
        </div>

        <div class="tab-pane" id="radius" role="tabpanel" aria-labelledby="radius-pill">
            {{ form_row(form.guest_realm) }}
            {{ form_row(form.freeradius_keep_days) }}
            <h3 class="mt-4">CoA</h3>
            {{ form_row(form.coa_endpoint) }}
            {{ form_row(form.coa_pattern) }}
            {{ form_row(form.coa_password) }}
            {{ form_row(form.coa_activation_endpoint) }}
            {{ form_row(form.coa_deactivation_endpoint) }}

            <div class="mt-3 d-flex justify-content-center">
                <input type="submit" value="Salva" class="btn btn-primary"/>
            </div>
        </div>

        <div class="tab-pane" id="appleSchool" role="tabpanel" aria-labelledby="appleSchool-pill">
            {% if appleSchools %}
                <ul class="list-group">
                    {% for appleSchool in appleSchools %}
                        <li class="list-group-item d-flex align-items-center">
                            {# <span class="badge">{{ provider.uri }}</span> #}

                            <i class="{{ appleSchool.active  ? 'c-teal-500 fas fa-check' : 'c-deep-orange-500 fas fa-times' }} me-2"></i>
                            <a href="{{ path('config_apple_school_edit', { 'id': appleSchool.id }) }}">{{ appleSchool.organizationName }}</a>

                            <div class="ms-auto">
                                <a href="{{ path('config_apple_school_edit', { 'id': appleSchool.id }) }}" class="btn btn-primary btn-sm">Modifica</a>
                            </div>
                        </li>

                    {% endfor %}
                </ul>
            {% endif %}
            <div class="mt-3 d-flex justify-content-center">
                <a class="btn btn-success" href="{{ path('config_apple_school_create') }}">
                    Aggiungi
                </a>
            </div>
        </div>

        <div class="tab-pane" id="mdmServer">
            {% if mdmServers %}
                <ul class="list-group">
                    {% for mdmServer in mdmServers %}
                        <li class="list-group-item d-flex align-items-center">
                            <i class="{{ mdmServer.active  ? 'c-teal-500 fas fa-check' : 'c-deep-orange-500 fas fa-times' }} me-2"></i>
                            <a href="{{ path('config_mdmServer_edit', { 'id': mdmServer.id }) }}">{{ mdmServer.name }}</a>
                            <div class="ms-auto">
                                <a href="{{ path('config_mdmServer_edit', { 'id': mdmServer.id }) }}" class="btn btn-primary btn-sm">Modifica</a>
                            </div>
                        </li>
                    {% endfor %}
                </ul>
            {% endif %}
            <div class="mt-3 d-flex justify-content-center">
                <a class="btn btn-success" href="{{ path('config_mdmServer_new') }}">
                    Aggiungi
                </a>
            </div>
        </div>
    </div>


    {{ form_row(form.save, {'attr': {'class' : 'btn btn-success d-none'}}) }}
    {{ form_rest(form) }}
    {{ form_end(form) }}
</div>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script type="text/javascript">

        $(document).ready(function () {
            function checkAdVisibility() {
                if ($("#configuration_onlyReception").prop('checked')) {
                    $("#showAdDiv").hide();
                    $("#showAdLi").hide();
                    $("#showProviderLi").hide();
                } else {
                    $("#showAdDiv").show();
                    $("#showAdLi").show();
                    $("#showProviderLi").show();
                }
                if ($("#configuration_guestCanRegisterViaSms").prop('checked')) {
                    $("#showSkebbyDiv").show();
                } else {
                    $("#showSkebbyDiv").hide();
                }
                if ($("#configuration_disableMikrotik").prop('checked')) {
                    $("#mikrotikDiv").hide();
                } else {
                    $("#mikrotikDiv").show();
                }
            }

            $("#configuration_onlyReception").change(function () {
                checkAdVisibility();
            });
            $("#configuration_showStats").change(function () {
                checkAdVisibility();
            });
            $("#configuration_guestCanRegisterViaSms").change(function () {
                checkAdVisibility();
            });
            $("#configuration_disableMikrotik").change(function () {
                checkAdVisibility();
            });
            checkAdVisibility();


            $.fn.historypills = function () {
                window.addEventListener('popstate', function (event) {
                    if (event.state) {
                        const currentTab = document.querySelector('[data-bs-target="' + event.state.url + '"]');
                        const curTab = new bootstrap.Tab(currentTab);
                        curTab.show();
                    }
                });
                return this.each(function (index, element) {
                    $(element).on('show.bs.tab', function (event) {
                        let url = $(event.target).attr('data-bs-target');
                        let stateObject = {'url': url};

                        if (window.location.hash && stateObject.url !== window.location.hash) {
                            window.history.pushState(stateObject, document.title, window.location.pathname + url);
                        } else {
                            window.history.replaceState(stateObject, document.title, window.location.pathname + url);
                        }
                    });
                    if (!window.location.hash && $(element).is('.active')) {
                        // Shows the first element if there are no query parameters.
                        const curTab = new bootstrap.Tab(element);
                        curTab.show();
                    } else if ($(this).attr('data-bs-target') === window.location.hash) {
                        const curTab = new bootstrap.Tab(element);
                        curTab.show();
                    }
                });
            };
            $('button[data-bs-toggle="pill"]').historypills();
        })

    </script>
{% endblock %}
